org.eclipse.swt.widgets

## Class Slider

- java.lang.Object
- - org.eclipse.swt.widgets.Widget
  - - org.eclipse.swt.widgets.Control
    - - org.eclipse.swt.widgets.Slider

All Implemented Interfaces:
  Adaptable, Drawable

    public class Slider
    extends Control

Instances of this class are selectable user interface objects that represent a range of positive, numeric values.

At any given moment, a given slider will have a single 'selection' that is considered to be its value, which is constrained to be within the range of values the slider represents (that is, between its minimum and maximum values).

Typically, sliders will be made up of five areas:

1. an arrow button for decrementing the value
2. a page decrement area for decrementing the value by a larger amount
3. a thumb for modifying the value by mouse dragging
4. a page increment area for incrementing the value by a larger amount
5. an arrow button for incrementing the value

Based on their style, sliders are either `HORIZONTAL` (which have a left facing button for decrementing the value and a right facing button for incrementing it) or `VERTICAL` (which have an upward facing button for decrementing the value and a downward facing buttons for incrementing it).

On some platforms, the size of the slider's thumb can be varied relative to the magnitude of the range of values it represents (that is, relative to the difference between its maximum and minimum values). Typically, this is used to indicate some proportional value such as the ratio of the visible area of a document to the total amount of space that it would take to display it. SWT supports setting the thumb size even if the underlying platform does not, but in this case the appearance of the slider will not change.

Styles:
  HORIZONTAL, VERTICAL
Events:
  Selection

Note: Only one of the styles HORIZONTAL and VERTICAL may be specified.

IMPORTANT: This class is not intended to be subclassed.

Since:
  1.2
See Also:
  `ScrollBar`

### Constructor Summary

Constructors
Constructor and Description
`Slider(Composite parent, int style)` Constructs a new instance of this class given its parent and a style value describing its behavior and appearance.

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `addSelectionListener(SelectionListener listener)` Adds the listener to the collection of listeners who will be notified when the user changes the receiver's value, by sending it one of the messages defined in the `SelectionListener` interface.
`Point` `computeSize(int wHint, int hHint, boolean changed)` Returns the preferred size of the receiver.
`<T> T` `getAdapter(java.lang.Class<T> adapter)` Implementation of the `Adaptable` interface.
`int` `getIncrement()` Returns the amount that the receiver's value will be modified by when the up/down (or right/left) arrows are pressed.
`int` `getMaximum()` Returns the maximum value which the receiver will allow.
`int` `getMinimum()` Returns the minimum value which the receiver will allow.
`int` `getPageIncrement()` Returns the amount that the receiver's value will be modified by when the page increment/decrement areas are selected.
`int` `getSelection()` Returns the 'selection', which is the receiver's value.
`int` `getThumb()` Returns the size of the receiver's thumb relative to the difference between its maximum and minimum values.
`void` `removeSelectionListener(SelectionListener listener)` Removes the listener from the collection of listeners who will be notified when the user changes the receiver's value.
`void` `setIncrement(int value)` Sets the amount that the receiver's value will be modified by when the up/down (or right/left) arrows are pressed to the argument, which must be at least one.
`void` `setMaximum(int value)` Sets the maximum.
`void` `setMinimum(int value)` Sets the minimum value.
`void` `setPageIncrement(int value)` Sets the amount that the receiver's value will be modified by when the page increment/decrement areas are selected to the argument, which must be at least one.
`void` `setSelection(int value)` Sets the 'selection', which is the receiver's value, to the argument which must be greater than or equal to zero.
`void` `setThumb(int value)` Sets the size of the receiver's thumb relative to the difference between its maximum and minimum values.
`void` `setValues(int selection, int minimum, int maximum, int thumb, int increment, int pageIncrement)` Sets the receiver's selection, minimum value, maximum value, thumb, increment and page increment all at once.

### Methods inherited from class org.eclipse.swt.widgets.Control

`addControlListener, addDragDetectListener, addFocusListener, addGestureListener, addHelpListener, addKeyListener, addMenuDetectListener, addMouseListener, addTouchListener, addTraverseListener, computeSize, forceFocus, getAccessible, getBackground, getBackgroundImage, getBorderWidth, getBounds, getCursor, getEnabled, getFont, getForeground, getLayoutData, getLocation, getMenu, getMonitor, getOrientation, getParent, getShell, getSize, getToolTipText, getTouchEnabled, getVisible, isEnabled, isFocusControl, isReparentable, isVisible, moveAbove, moveBelow, pack, pack, redraw, redraw, removeControlListener, removeDragDetectListener, removeFocusListener, removeGestureListener, removeHelpListener, removeKeyListener, removeMenuDetectListener, removeMouseListener, removeTouchListener, removeTraverseListener, requestLayout, setBackground, setBackgroundImage, setBounds, setBounds, setCursor, setData, setEnabled, setFocus, setFont, setForeground, setLayoutData, setLocation, setLocation, setMenu, setOrientation, setParent, setRedraw, setSize, setSize, setToolTipText, setTouchEnabled, setVisible, toControl, toControl, toDisplay, toDisplay, update`

### Methods inherited from class org.eclipse.swt.widgets.Widget

`addDisposeListener, addListener, checkSubclass, checkWidget, dispose, getData, getData, getDisplay, getListeners, getStyle, isDisposed, isListening, notifyListeners, removeDisposeListener, removeListener, removeListener, reskin, setData, toString`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### Slider

    public Slider(Composite parent,
                  int style)

Constructs a new instance of this class given its parent and a style value describing its behavior and appearance.

The style value is either one of the style constants defined in class `SWT` which is applicable to instances of this class, or must be built by bitwise OR'ing together (that is, using the `int` "|" operator) two or more of those `SWT` style constants. The class description lists the style constants that are applicable to the class. Style bits are also inherited from superclasses.

Parameters:
  `parent` - a composite control which will be the parent of the new instance (cannot be null)
  `style` - the style of control to construct
Throws:
  `java.lang.IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the parent is null
  `SWTException` -
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the parent
  - ERROR_INVALID_SUBCLASS - if this class is not an allowed subclass
See Also:
  `SWT.HORIZONTAL`, `SWT.VERTICAL`, `Widget.checkSubclass()`, `Widget.getStyle()`

### Method Detail

#### addSelectionListener

    public void addSelectionListener(SelectionListener listener)

Adds the listener to the collection of listeners who will be notified when the user changes the receiver's value, by sending it one of the messages defined in the `SelectionListener` interface.

When `widgetSelected` is called, the event object detail field contains one of the following values: `SWT.NONE` - for the end of a drag. `SWT.DRAG`. `SWT.HOME`. `SWT.END`. `SWT.ARROW_DOWN`. `SWT.ARROW_UP`. `SWT.PAGE_DOWN`. `SWT.PAGE_UP`. `widgetDefaultSelected` is not called.

Parameters:
  `listener` - the listener which should be notified when the user changes the receiver's value
Throws:
  `java.lang.IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the listener is null
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
See Also:
  `SelectionListener`, `removeSelectionListener(org.eclipse.swt.events.SelectionListener)`, `SelectionEvent`

#### removeSelectionListener

    public void removeSelectionListener(SelectionListener listener)

Removes the listener from the collection of listeners who will be notified when the user changes the receiver's value.

Parameters:
  `listener` - the listener which should no longer be notified
Throws:
  `java.lang.IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the listener is null
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
See Also:
  `SelectionListener`, `addSelectionListener(org.eclipse.swt.events.SelectionListener)`

#### computeSize

    public Point computeSize(int wHint,
                             int hHint,
                             boolean changed)

Description copied from class: `Control`
Returns the preferred size of the receiver.

The preferred size of a control is the size that it would best be displayed at. The width hint and height hint arguments allow the caller to ask a control questions such as "Given a particular width, how high does the control need to be to show all of the contents?" To indicate that the caller does not wish to constrain a particular dimension, the constant `SWT.DEFAULT` is passed for the hint.

If the changed flag is `true`, it indicates that the receiver's contents have changed, therefore any caches that a layout manager containing the control may have been keeping need to be flushed. When the control is resized, the changed flag will be `false`, so layout manager caches can be retained.

Overrides:
  `computeSize` in class `Control`
Parameters:
  `wHint` - the width hint (can be `SWT.DEFAULT`)
  `hHint` - the height hint (can be `SWT.DEFAULT`)
  `changed` - `true` if the control's contents have changed, and `false` otherwise
Returns:
  the preferred size of the control.
See Also:
  `Layout`, `Control.getBorderWidth()`, `Control.getBounds()`, `Control.getSize()`, `Control.pack(boolean)`, "computeTrim, getClientArea for controls that implement them"

#### getIncrement

    public int getIncrement()

Returns the amount that the receiver's value will be modified by when the up/down (or right/left) arrows are pressed.

Returns:
  the increment
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getMaximum

    public int getMaximum()

Returns the maximum value which the receiver will allow.

Returns:
  the maximum
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getMinimum

    public int getMinimum()

Returns the minimum value which the receiver will allow.

Returns:
  the minimum
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getPageIncrement

    public int getPageIncrement()

Returns the amount that the receiver's value will be modified by when the page increment/decrement areas are selected.

Returns:
  the page increment
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getSelection

    public int getSelection()

Returns the 'selection', which is the receiver's value.

Returns:
  the selection
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getThumb

    public int getThumb()

Returns the size of the receiver's thumb relative to the difference between its maximum and minimum values.

Returns:
  the thumb value
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### setIncrement

    public void setIncrement(int value)

Sets the amount that the receiver's value will be modified by when the up/down (or right/left) arrows are pressed to the argument, which must be at least one.

Parameters:
  `value` - the new increment (must be greater than zero)
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### setMaximum

    public void setMaximum(int value)

Sets the maximum. If this value is negative or less than or equal to the minimum, the value is ignored. If necessary, first the thumb and then the selection are adjusted to fit within the new range.

Parameters:
  `value` - the new maximum, which must be greater than the current minimum
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### setMinimum

    public void setMinimum(int value)

Sets the minimum value. If this value is negative or greater than or equal to the maximum, the value is ignored. If necessary, first the thumb and then the selection are adjusted to fit within the new range.

Parameters:
  `value` - the new minimum
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### setPageIncrement

    public void setPageIncrement(int value)

Sets the amount that the receiver's value will be modified by when the page increment/decrement areas are selected to the argument, which must be at least one.

Parameters:
  `value` - the page increment (must be greater than zero)
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### setSelection

    public void setSelection(int value)

Sets the 'selection', which is the receiver's value, to the argument which must be greater than or equal to zero.

Parameters:
  `value` - the new selection (must be zero or greater)
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### setThumb

    public void setThumb(int value)

Sets the size of the receiver's thumb relative to the difference between its maximum and minimum values. This new value will be ignored if it is less than one, and will be clamped if it exceeds the receiver's current range.

Parameters:
  `value` - the new thumb value, which must be at least one and not larger than the size of the current range
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### setValues

    public void setValues(int selection,
                          int minimum,
                          int maximum,
                          int thumb,
                          int increment,
                          int pageIncrement)

Sets the receiver's selection, minimum value, maximum value, thumb, increment and page increment all at once.

Note: This is similar to setting the values individually using the appropriate methods, but may be implemented in a more efficient fashion on some platforms.

Parameters:
  `selection` - the new selection value
  `minimum` - the new minimum value
  `maximum` - the new maximum value
  `thumb` - the new thumb value
  `increment` - the new increment value
  `pageIncrement` - the new pageIncrement value
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getAdapter

    public <T> T getAdapter(java.lang.Class<T> adapter)

Description copied from class: `Widget`
Implementation of the `Adaptable` interface.

IMPORTANT: This method is not part of the RWT public API. It is marked public only so that it can be shared within the packages provided by RWT. It should never be accessed from application code.

Specified by:
  `getAdapter` in interface `Adaptable`
Overrides:
  `getAdapter` in class `Control`
Parameters:
  `adapter` - the lookup class
Returns:
  an object that can be cast to the given class or `null` if there is no adapter associated with the given class.

Copyright (c) EclipseSource and others 2002, 2016. All rights reserved. This program and the accompanying materials are made available under the terms of the Eclipse Public License v1.0